<?php

namespace Litepie\Master;

use User;

class Master
{
    /**
     * $master object.
     */
    protected $master;

    /**
     * Constructor.
     */
    public function __construct(\Litepie\Master\Interfaces\MasterRepositoryInterface $master)
    {
        $this->master = $master;
    }

    /**
     * Returns count of master.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.master.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->master->pushCriteria(new \Litepie\Litepie\Repositories\Criteria\MasterUserCriteria());
        }

        $master = $this->master->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('master::' . $view, compact('master'))->render();
    }
}
